--[[
	TitanMastery: A simple Display of current mastery value as a percent
	Author: Fury - credit to Subwired for base lua
	Date: 22-11-2015
--]]

local menutext = "Titan|cffff8800 Mastery|r"
local buttonlabel = "Mastery: "
local ID = "MA"
local elap, MA, prevMA = 0, 0.0, -2
local GetUnitMA = 0

-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelMAButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")

function f:ADDON_LOADED(a1)
--print ("a1 = " .. a1)
	if a1 ~= "TitanMastery" then
	return 
	end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil		

	self.registry = {
		id = ID,
		menuText = menutext,
		buttonTextFunction = "TitanPanelMAButton_GetButtonText",
		tooltipTitle = ID,
		tooltipTextFunction = "TitanPanelMAButton_GetTooltipText",
		frequency = 0.5,
		icon = "Interface\\Icons\\Ability_warrior_weaponmastery.blp",
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			
		},
	}
	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 1 then return end
		
		MA = GetMasteryEffect();
		
		if MA == prevMA then return end
		prevMA  = MA
		TitanPanelButton_UpdateButton(ID)
		elap = 0
	end)
		
	--TitanPanelButton_OnLoad(self)
end

----------------------------------------------
function TitanPanelMAButton_GetButtonText()
----------------------------------------------
	local MAtext, pitchtext
	if not MA then
		MAtext = "??"
	else
		MAtext = string.format("%.2f", MA) .."%" 
	end
	return buttonlabel, MAtext
end

-----------------------------------------------
function TitanPanelMAButton_GetTooltipText()
-----------------------------------------------
	return "Displays your current Mastery value as a percent"
end

local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
	temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
	UIDropDownMenu_AddButton(temp)
end
----------------------------------------------------
function TitanPanelRightClickMenu_PrepareMAMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end